org.richfaces.ui.iteration.dataGrid

## Class AbstractDataGrid

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - org.richfaces.ui.iteration.UIDataAdaptor
      - - org.richfaces.ui.iteration.UISequence
        - - org.richfaces.ui.iteration.dataGrid.AbstractDataGrid

- All Implemented Interfaces:
    EventListener, javax.faces.component.NamingContainer, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.component.UniqueIdVendor, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListener, javax.faces.event.SystemEventListenerHolder, MetaComponentEncoder, MetaComponentResolver, IterationStateHolder, Row
  Direct Known Subclasses:
    UIDataGrid

      public abstract class AbstractDataGrid
      extends UISequence
      implements Row, MetaComponentResolver, MetaComponentEncoder

  The <r:dataGrid> component is used to arrange data objects in a grid. Values in the grid can be updated dynamically from the data model, and Ajax updates can be limited to specific rows. The component supports header, footer, and caption facets.

  Author:
    Anton Belevich

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.richfaces.ui.iteration.UIDataAdaptor

      `UIDataAdaptor.ComponentVisitor`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BODY`
    `static String` | `CAPTION_FACET_NAME`
    `static String` | `COMPONENT_FAMILY`
    `static String` | `COMPONENT_TYPE`
    `static String` | `FOOTER`
    `static String` | `FOOTER_FACET_NAME`
    `static String` | `HEADER`
    `static String` | `HEADER_FACET_NAME`
    `static String` | `NODATA_FACET_NAME`

    - ### Fields inherited from class org.richfaces.ui.iteration.UIDataAdaptor

      `decodeVisitor, updateVisitor, validateVisitor`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

    - ### Fields inherited from interface org.richfaces.ui.common.meta.MetaComponentResolver

      `META_COMPONENT_SEPARATOR_CHAR`

    - ### Fields inherited from interface javax.faces.component.NamingContainer

      `SEPARATOR_CHAR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractDataGrid()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Iterator<javax.faces.component.UIComponent>` | `columns()` Get iterator for all columns contained in this row.
    `void` | `encodeMetaComponent(javax.faces.context.FacesContext context, String metaComponentId)`
    `abstract javax.faces.component.UIComponent` | `getCaption()`
    `int` | `getColumns()` Number of columns to display
    `abstract int` | `getElements()` Number of elements displayed in the grid
    `abstract javax.faces.component.UIComponent` | `getFooter()`
    `abstract javax.faces.component.UIComponent` | `getHeader()`
    `abstract javax.faces.component.UIComponent` | `getNoData()`
    `abstract int` | `getRows()`
    `String` | `resolveClientId(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent contextComponent, String metaComponentId)` Resolves and returns string identifying supported meta-component or `null` if provided meta-component name is not a supported one.
    `void` | `setColumns(int count)`
    `String` | `substituteUnresolvedClientId(javax.faces.context.FacesContext facesContext, javax.faces.component.UIComponent contextComponent, String metaComponentId)` Provides replacement for unresolved meta-component names.
    `protected boolean` | `visitDataChildren(javax.faces.component.visit.VisitContext visitContext, javax.faces.component.visit.VisitCallback callback, boolean visitRows)`
    `protected boolean` | `visitFixedChildren(javax.faces.component.visit.VisitContext visitContext, javax.faces.component.visit.VisitCallback callback)`

    - ### Methods inherited from class org.richfaces.ui.iteration.UISequence

      `captureOrigValue, createComponentState, createExtendedDataModel, createFacesModel, getActualFirst, getActualRows, getFirst, getIterationStatusVar, getRelativeClientId, getRelativeRowIndex, getRowIndex, getRowKeyConverter, getValue, preEncodeBegin, restoreOrigValue, setFirst, setIterationStatusVar, setRows, setupVariable, setValue, setValueBinding, setValueExpression, updateState, updateState`

    - ### Methods inherited from class org.richfaces.ui.iteration.UIDataAdaptor

      `allFixedChildren, broadcast, clearExtendedDataModel, clearInitialState, createUniqueId, dataChildren, doUpdate, extractKeySegment, fixedChildren, getComponentState, getContainerClientId, getContainerClientId, getExtendedDataModel, getFamily, getIterationState, getLocalComponentState, getRowCount, getRowData, getRowKey, getRowKeyVar, getStateVar, getVar, getVariablesMap, invokeOnComponent, invokeOnRow, isKeepSaved, isListenerForSource, isRowAvailable, iterate, keepSaved, markInitialState, preDecode, preUpdate, preValidate, processDecodes, processDecodesChildren, processEvent, processEvent, processUpdates, processUpdatesChildren, processValidatesChildren, processValidators, queueEvent, resetChildState, resetDataModel, restoreChildState, restoreChildState, restoreState, saveChildState, saveChildState, saveState, setExtendedDataModel, setId, setIterationState, setKeepSaved, setRowKey, setRowKey, setRowKeyConverter, setRowKeyVar, setStateVar, setVar, visitDataChildrenMetaComponents, visitTree, walk, wrapEvent`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addClientBehavior, addFacesListener, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getDefaultEventName, getEventNames, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, isRendered, isTransient, processRestoreState, processSaveState, removeFacesListener, restoreAttachedState, saveAttachedState, setParent, setRendered, setRendererType, setTransient, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, pushComponentToEL, restoreTransientState, saveTransientState, setInView`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.richfaces.ui.iteration.Row

      `setRowKey, walk`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### COMPONENT_FAMILY

          public static final String COMPONENT_FAMILY

      See Also:
        Constant Field Values

    - #### HEADER_FACET_NAME

          public static final String HEADER_FACET_NAME

      See Also:
        Constant Field Values

    - #### FOOTER_FACET_NAME

          public static final String FOOTER_FACET_NAME

      See Also:
        Constant Field Values

    - #### CAPTION_FACET_NAME

          public static final String CAPTION_FACET_NAME

      See Also:
        Constant Field Values

    - #### NODATA_FACET_NAME

          public static final String NODATA_FACET_NAME

      See Also:
        Constant Field Values

    - #### HEADER

          public static final String HEADER

      See Also:
        Constant Field Values

    - #### FOOTER

          public static final String FOOTER

      See Also:
        Constant Field Values

    - #### BODY

          public static final String BODY

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractDataGrid

          public AbstractDataGrid()

  - ### Method Detail

    - #### getElements

          public abstract int getElements()

      Number of elements displayed in the grid

    - #### getRows

          public abstract int getRows()

      Overrides:
        `getRows` in class `UISequence`

    - #### getHeader

          public abstract javax.faces.component.UIComponent getHeader()

    - #### getFooter

          public abstract javax.faces.component.UIComponent getFooter()

    - #### getCaption

          public abstract javax.faces.component.UIComponent getCaption()

    - #### getNoData

          public abstract javax.faces.component.UIComponent getNoData()

    - #### getColumns

          public int getColumns()

      Number of columns to display

    - #### setColumns

          public void setColumns(int count)

    - #### columns

          public Iterator<javax.faces.component.UIComponent> columns()

      Description copied from interface: `Row`
      Get iterator for all columns contained in this row.
      Specified by:
        `columns` in interface `Row`

    - #### encodeMetaComponent

          public void encodeMetaComponent(javax.faces.context.FacesContext context,
                                 String metaComponentId)
                                   throws IOException

      Specified by:
        `encodeMetaComponent` in interface `MetaComponentEncoder`
      Throws:
        `IOException`

    - #### visitFixedChildren

          protected boolean visitFixedChildren(javax.faces.component.visit.VisitContext visitContext,
                                   javax.faces.component.visit.VisitCallback callback)

      Overrides:
        `visitFixedChildren` in class `UIDataAdaptor`

    - #### visitDataChildren

          protected boolean visitDataChildren(javax.faces.component.visit.VisitContext visitContext,
                                  javax.faces.component.visit.VisitCallback callback,
                                  boolean visitRows)

      Overrides:
        `visitDataChildren` in class `UIDataAdaptor`

    - #### resolveClientId

          public String resolveClientId(javax.faces.context.FacesContext facesContext,
                               javax.faces.component.UIComponent contextComponent,
                               String metaComponentId)

      Description copied from interface: `MetaComponentResolver`
      Resolves and returns string identifying supported meta-component or `null` if provided meta-component name is not a supported one.
      Specified by:
        `resolveClientId` in interface `MetaComponentResolver`
      Parameters:
        `facesContext` - - current instance of `FacesContext`
        `contextComponent` - - instance of `UIComponent` that requested resolution of meta-component
        `metaComponentId` - - name of meta-component (without leading '@' sign)
      Returns:
        clientId, one of supported meta-names such as @all, @this, etc. or `null`

    - #### substituteUnresolvedClientId

          public String substituteUnresolvedClientId(javax.faces.context.FacesContext facesContext,
                                            javax.faces.component.UIComponent contextComponent,
                                            String metaComponentId)

      Description copied from interface: `MetaComponentResolver`
      Provides replacement for unresolved meta-component names. Returns identifier string for the chosen substitution or `null`
      Specified by:
        `substituteUnresolvedClientId` in interface `MetaComponentResolver`
      Parameters:
        `facesContext` - - current instance of `FacesContext`
        `contextComponent` - - instance of `UIComponent` that requested resolution of meta-component
        `metaComponentId` - - name of meta-component (without leading '@' sign)
      Returns:
        clientId, one of supported meta-names such as @all, @this, etc. or `null`

Copyright © 2013 JBoss by Red Hat. All Rights Reserved.